#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

char *canary_abort_message =
"Canary %d = %x died in procedure %s!!! Probable buffer overflow attack!!\n" ;

long __canary[128] ;

/* causes loader to execute canary_setup() before main */

void canary_setup ( void ) __attribute__ ((__constructor__)) ;

void canary_setup ( void ) {
  struct timeval seed ;
  int i ;

  /* gettimeofday() -- use time of day to seed srandom() */
  /* A better seed would be to read /dev/random */

  {
    int ret = gettimeofday (&seed, NULL) ;
    if ( ret == 0 ) {
      fprintf (stderr, "gettimeofday succeeded\n") ;
    } else {
      fprintf (stderr, "gettimeofday failed, errno = %s\n", errno) ;
      exit (1) ;
    }
  }

  /* Seed the random function with seconds XOR microseconds */
  
  srandom (seed.tv_sec ^ seed.tv_usec) ;
  
  /* Fill in the vector of canaries */
  
  for ( i = 0 ; i < 128 ; i ++ ) {
    __canary[i] = random () ;
    /*    fprintf (stderr, "canary[%d] = %d\n", i, __canary[i]) ; */
  }
  
  /* Reset the random seed with the default */

  srandom (1) ;
  
  return ;
}
